/*
 * EasySHP ESRI  SHP Ӽ   DBF óϱ  ڹ Ŭ Դϴ.
 * EasySHP   ϸ  Java ̺귯Դϴ.
 * Geometry JTS ̺귯 Ͽ Geometry  پ   ״   ֽϴ.
 * 
 * ۱ (C) 2011 (GeoService)
 * 
 *  ̺귯  ƮԴϴ.
 * GNU LGPL    /ְų   ֽϴ.
 *  Ʈ Կ ־ ߻ϴ  å ʽϴ.
 * 
 *  ڼ  ؼ  ó  Ͻñ ٶϴ.
 * 
 *      hjkim@geoservice.co.kr
 *      www.gisdeveloper.co.kr
 * Ȩ  www.geoservice.co.kr 
 * 
 * մϴ.
 */

package geoservice.easyshp.dbf;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.channels.FileChannel;

/**
 * SHP Ӽ Ͱ  DBF  óϱ  Ŭ.
 * 
 * @author GEOSERVICE
 * @version 1.0
 */
public class AccessDBF {
	private FileInputStream dbfStream = null; // DBF  ڵ
	private String date = null; // DBF   ¥
	private short rowLength = 0; // DBF  ϴ row byte ũ
	private short headerLength = 0; // DBF   
	private int rowInitCount = 0; // DBF   õ row 
	private RowSetDBF rowSet = null; // row 
	private FieldSet fieldSet = null; // field 
	
	/**
	 * DBF  ڵ 
	 */
	public FileInputStream getStreamDBF() { 
		return dbfStream;
	}
	
	/**
	 * DBF  ϴ row  (DBF  Ͽ õ row )
	 */
	public int getRowInitCount() {
		return rowInitCount;
	}
	
	/**
	 * row  
	 */
	public RowSetDBF getRowSet() {
		return rowSet;
	}

	/**
	 * field  
	 * @return
	 */
	public FieldSet getFieldSet() {
		return fieldSet;
	}
	
	/**
	 * DBF   (byte )  
	 */
	public short getHeaderLength() {
		return headerLength;
	}

	/**
	 * row ϳ (byte ) 
	 * @return
	 */
	public short getRowLength() {
		return rowLength;
	}
	
	/**
	 * DBF   ¥ 
	 * @return
	 */
	public String getDate() {
		return date;
	}
	
	/**
	 *  ҽ ȯ
	 */
	public void release() {
		try {
			if(dbfStream != null) dbfStream.close();
		} catch(IOException e) {
			e.printStackTrace(System.err);
		}
		
		rowSet = null;
		dbfStream = null;
		fieldSet = null;
	}
	
	/**
	 * 
	 * @param fileNameDBF  ϴ DBF ϸ
	 */
	public AccessDBF(String fileNameDBF) {
		open(fileNameDBF);
	}
	
	/**
	 * DBF    
	 * @return ϸ <code>true</code> ȯ
	 */
	private boolean readDBFHeader() {
		FileChannel channel = dbfStream.getChannel();
		
		ByteBuffer buf = ByteBuffer.allocate(32);
		buf.order(ByteOrder.LITTLE_ENDIAN);
		try {
			channel.read(buf);
			buf.flip();
			
			buf.get(); // byte Version
			byte Year = buf.get();
			byte Month = buf.get();
			byte Day = buf.get();
			rowInitCount = buf.getInt();
			headerLength = buf.getShort();
			rowLength = buf.getShort();
			int FieldCount = (headerLength/32)-1;
			
			date = (1900 + Year) + "/" + Month + "/" + Day;
			
			fieldSet = new FieldSet();
			
			for(int iField=0; iField<FieldCount; ++iField) {
				buf.clear();
				channel.read(buf);
				buf.flip();
				
				byte[] FieldName = new byte[11];
				buf.get(FieldName);
				String strFieldName = new String(FieldName);
				byte FieldType = buf.get();
				buf.getInt(); // int Address
				int ColumnLength = buf.get() & 0x000000FF;
				byte DecimalLength = buf.get();
				
				Field field = new Field(strFieldName.trim(), FieldType, ColumnLength, DecimalLength);
				fieldSet.addField(field);
			}
			
			rowSet = new RowSetDBF(this);
		} catch(IOException e) {
			e.printStackTrace(System.err);
			return false;
		}
		
		return true;
	}
	
	/**
	 * DBF   DBF  ϴ row   ֵ غ մϴ. 
	 * @param fileNameDBF DBF ϸ 
	 * @return   <code>true</code> ȯ
	 */
	public boolean open(String fileNameDBF) {
		release();

		File dbfFile = new File(fileNameDBF);
		if(!dbfFile.exists()) return false;

		dbfStream = null;
		try {
			dbfStream = new FileInputStream(dbfFile);
		} catch(FileNotFoundException e) {
			e.printStackTrace(System.err);
			return false;
		}		
		
		return readDBFHeader();
	}
}
