/*
 * EasySHP ESRI  SHP Ӽ   DBF óϱ  ڹ Ŭ Դϴ.
 * EasySHP   ϸ  Java ̺귯Դϴ.
 * Geometry JTS ̺귯 Ͽ Geometry  پ   ״   ֽϴ.
 * 
 * ۱ (C) 2011 (GeoService)
 * 
 *  ̺귯  ƮԴϴ.
 * GNU LGPL    /ְų   ֽϴ.
 *  Ʈ Կ ־ ߻ϴ  å ʽϴ.
 * 
 *  ڼ  ؼ  ó  Ͻñ ٶϴ.
 * 
 *      hjkim@geoservice.co.kr
 *      www.gisdeveloper.co.kr
 * Ȩ  www.geoservice.co.kr 
 * 
 * մϴ.
 */

package geoservice.easyshp.dbf;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.FileChannel;
import java.util.Vector;

/**
 * DBF ϴ row Ŭ
 * row  ʵ忡    ؼ load ż带 ȣ ޸𸮿 ÷ մϴ.
 * ʵ忡    ̻ ʿġ   unload ż带 ȣϿ ޸𸮸   ֽϴ.
 * 
 * @author GEOSERVICE
 * @version 1.0
 */
public class RowDBF {
	private int fid = -1; // row id
	private Vector<String> values = null; // row  ʵ忡 شϴ  
	private AccessDBF control = null; // DBF Ϸκ row  б  Ʈ
	
	/**
	 * row ʱ⿡ fid      ϴ.
	 *  ż带 ȣϿ   DBF Ϸκ о  ֽϴ.
	 *  unload ȣϿ ޸𸮸   ֽϴ.
	 * @return   <code>true</code> ȯ
	 * @throws IOException DBF Ϸκ б   ߻ϴ 
	 */
	public boolean load() throws IOException {
		if(values == null) {
			FileChannel channel = control.getStreamDBF().getChannel();
			short recordLength = control.getRowLength();
			short headerLength = control.getHeaderLength();
			ByteBuffer buf = ByteBuffer.allocate(recordLength);
			FieldSet fieldSet = control.getFieldSet();
			int cntFields = fieldSet.getFieldsCount();
			int posRow = headerLength + (fid-1)*recordLength;
			
			channel.position(posRow);
			channel.read(buf);
			buf.flip();
			buf.get(); // byte RecordStatus(0x2a: deleted)

			values = new Vector<String>();

			for(int iField=0; iField<cntFields; ++iField) {
				int columnLength = fieldSet.getField(iField).getColumnLength();
				byte[] valueBuf= new byte[columnLength];
				buf.get(valueBuf);
				String value = new String(valueBuf);
				values.add(value.trim());
			}
			
			control.getRowSet().addRow(this);
		}
		
		return true;
	}

	/**
	 * load ż带  о row  ޸ 󿡼 
	 * ʿҶ load  ޸𸮿 row  ø ٽ unload  ޸𸮸   
	 */
	public void unload() {
		control.getRowSet().deleteRow(fid);
		values = null;
	}
	
	/**
	 * ʵ    ʵ 
	 */
	public FieldSet getFieldSet() {
		return control.getFieldSet();
	}

	/**
	 * 
	 * @param fid row id
	 * @param control row DBF Ϸκ б  Ʈ
	 */
	public RowDBF(int fid, AccessDBF control) {
		this.fid = fid;
		this.control = control;
	}

	/**
	 * row id (1 )
	 * <b>SHP fid 1:1 踦 ΰ ֽϴ<b>
	 * @return
	 */
	public int getFID() {
		return fid;
	}
	
	/**
	 *  ε شϴ ʵ忡   
	 * ޸ 󿡼 Ǹ  Ͽ  ʽϴ.
	 * @param index  ϰ ϴ ʵ ε
	 * @param value ϰ ϴ 
	 */
	public void setValue(int index, String value) {
		values.set(index, value);
	}
	
	/**
	 *  ε شϴ  ڿ Ÿ ȯ
	 * @param index  ϴ  شϴ ʵ ε
	 * @return ڿ  
	 */
	public String getValueAsString(int index) {
		return values.get(index);
	}
	
	/**
	 *  ε شϴ   Ÿ ȯ
	 * @param index  ϴ  شϴ ʵ ε
	 * @return  
	 */
	public long getValueAsNumber(int index) {
		return Long.parseLong(values.get(index));
	}
	
	/** 
	 *  ε شϴ  Ǽ Ÿ ȯ
	 * @param index  ϴ  شϴ ʵ ε
	 * @return Ǽ 
	 */
	public double getValueAsFloat(int index) {
		return Double.parseDouble(values.get(index));
	}
}
