/*
 * EasySHP ESRI  SHP Ӽ   DBF óϱ  ڹ Ŭ Դϴ.
 * EasySHP   ϸ  Java ̺귯Դϴ.
 * Geometry JTS ̺귯 Ͽ Geometry  پ   ״   ֽϴ.
 * 
 * ۱ (C) 2011 (GeoService)
 * 
 *  ̺귯  ƮԴϴ.
 * GNU LGPL    /ְų   ֽϴ.
 *  Ʈ Կ ־ ߻ϴ  å ʽϴ.
 * 
 *  ڼ  ؼ  ó  Ͻñ ٶϴ.
 * 
 *      hjkim@geoservice.co.kr
 *      www.gisdeveloper.co.kr
 * Ȩ  www.geoservice.co.kr 
 * 
 * մϴ.
 */

package geoservice.easyshp.shp;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.channels.FileChannel;

import com.vividsolutions.jts.geom.Envelope;
import com.vividsolutions.jts.geom.GeometryFactory;

/**
 * ESRI  SHP  óϴ Ŭ
 * 
 * <h2>ϴ Shape Type</h2>
 * <ul>
 * 	<li>NullShape
 *  <li>Point
 *  <li>PolyLine
 *  <li>Polygon
 * </ul>
 * 
 * MultiPoint M, Z  Shape ׸ MultiPatch  Դϴ.
 *   SHP  б⸸ ϸ    Դϴ. 
 * 
 * @author GEOSERVICE
 * @version 1.0
 */
public class AccessSHP {
	private Envelope mbr = null; // ü  ϴ MBR(Minimun Bounding Rectangle)
	private RowSetSHP rowSet = null; // RowSet 
	private FileInputStream shpStream = null; // shp  ڵ 
	private FileInputStream shxStream = null; // shx  ڵ
	private GeometryFactory geomFactory = null; // JTS Geometry ϱ  丮
	
	/**
	 * JTS Geometry ϱ  丮 
	 */
	public GeometryFactory getGeometryFactory() {
		return geomFactory;
	}

	/**
	 * SHP  ڵ 
	 * @return
	 */
	public FileInputStream getStreamSHP() {
		return shpStream;
	}

	/**
	 * SHX  ڵ 
	 */
	public FileInputStream getStreamSHX() {
		return shxStream;
	}

	/**
	 * ʱȭ
	 */
	private void initialize() {
		geomFactory = new GeometryFactory();
	}
	
	/**
	 * 
	 */
	public AccessSHP() {
		initialize();
	}
	
	/**
	 * 
	 * @param fileNameSHP SHP  ̸
	 */
	public AccessSHP(String fileNameSHP) {
		initialize();
		open(fileNameSHP);
	}	

	/**
	 * SHP  ϴ ü  MBR 
	 * @return MBR
	 */
	public Envelope getMBR() {
		return mbr;
	}

	/**
	 * SHP   Ÿ 
	 * @return  Ÿν  ShapeType Ŭ  ǵǾ 
	 * @see ShapeType
	 */
	public int getShapeType() {
		return rowSet.getShapeType();
	}
	
	/**
	 * SHP  ϴ Row  
	 */
	public RowSetSHP getRowSet() {
		return rowSet;
	}
	
	/**
	 * SHP   ó
	 * @return  ó ǹٸ Ǿ  <code>true<code> ȯ 
	 */
	private boolean readSHPHeader() {
		ByteBuffer buf = ByteBuffer.allocate(100);
		
		try {
			FileChannel channel = shpStream.getChannel();
			channel.read(buf);
			buf.flip();
			
			int FileCode = buf.getInt(0);
			if(FileCode == 9994) {
				buf.getInt(24); // read FileLength(int) 
				
				buf.order(ByteOrder.LITTLE_ENDIAN);
				int Version = buf.getInt(28);
				if(Version == 1000) {
					int ShapeType = buf.getInt(32);

					rowSet = new RowSetSHP(ShapeType);

					double Xmin = buf.getDouble(36);
					double Ymin = buf.getDouble(44);
					double Xmax = buf.getDouble(52);
					double Ymax = buf.getDouble(60);			

					mbr = new Envelope(Xmin, Xmax, Ymin, Ymax);
				}
			}
		} catch(IOException e) {
			e.printStackTrace(System.err);
			return false;
		}
		
		return true;
	}
	
	/**
	 *  ҽ ȯ
	 */
	public void release() {
		mbr = null;
		rowSet = null;
		
		try {
			if(shxStream != null) shxStream.close();
			if(shpStream != null) shpStream.close();
		} catch(IOException e) {
			e.printStackTrace(System.err);
		}
		
		shxStream = null;
		shpStream = null;
	}
	
	/**
	 * SHP  ϴ Row о RowSHP ü Ŵ
	 * @param fileNameSHP SHP ̸
	 * @return   <code>true</code> ȯ
	 */
	private boolean buildRows(String fileNameSHP) {
		String fileNameSHX = fileNameSHP.toLowerCase().replace(".shp", ".shx");
		File shxFile = new File(fileNameSHX);
		if(!shxFile.exists()) return false;
		
		try {
			shxStream = new FileInputStream(shxFile);
		} catch(FileNotFoundException e) {
			e.printStackTrace(System.err);
			return false;
		}		
		
		File shpFile = new File(fileNameSHP);
		if(!shpFile.exists()) return false;

		try {
			shpStream = new FileInputStream(shpFile);
		} catch(FileNotFoundException e) {
			e.printStackTrace(System.err);
			return false;
		}		
		
		FileChannel channel = shpStream.getChannel();
		
		boolean bOK = false;
		
		bOK = readSHPHeader();
		if(!bOK) return false;
		
		ByteBuffer buf = ByteBuffer.allocate(36);
		try {
			long nextPosition = 100;
			while(nextPosition < channel.size()) {
				buf.limit(8);
				buf.position(0);
				
				channel.position(nextPosition);
				channel.read(buf);
				buf.flip();

				buf.order(ByteOrder.BIG_ENDIAN);
				int RecordNumber = buf.getInt(0);
				int ContentLength = buf.getInt(4) * 2;

				buf.clear();
				channel.read(buf);
				buf.flip();
				buf.order(ByteOrder.LITTLE_ENDIAN);
				
				Envelope rowMBR = null; 

				int shapeType = buf.getInt();
				if(ShapeType.hasMBR(shapeType)) {
					double Xmin = buf.getDouble();
					double Ymin = buf.getDouble();
					double Xmax = buf.getDouble();
					double Ymax = buf.getDouble();
					rowMBR = new Envelope(Xmin, Xmax, Ymin, Ymax);					
				} else {
					double X = buf.getDouble();
					double Y = buf.getDouble();
					rowMBR = new Envelope(X, X, Y, Y);
				}
				
				RowSHP row = new RowSHP(RecordNumber, rowMBR, this);
				rowSet.addRow(row);
				
				nextPosition += (4 + 4 + ContentLength);
			}
		} catch(IOException e) {
			e.printStackTrace(System.err);
			return false;
		}
		
		return true;
	}	
	
	/**
	 * SHP   SHP  ϴ row   ֵ غմϴ.
	 * @param fileNameSHP SHP  ̸
	 * @return   <code>true</code> ȯ
	 */
	public boolean open(String fileNameSHP) {
		release();
		return buildRows(fileNameSHP);
	}
}