/*
 * EasySHP ESRI  SHP Ӽ   DBF óϱ  ڹ Ŭ Դϴ.
 * EasySHP   ϸ  Java ̺귯Դϴ.
 * Geometry JTS ̺귯 Ͽ Geometry  پ   ״   ֽϴ.
 * 
 * ۱ (C) 2011 (GeoService)
 * 
 *  ̺귯  ƮԴϴ.
 * GNU LGPL    /ְų   ֽϴ.
 *  Ʈ Կ ־ ߻ϴ  å ʽϴ.
 * 
 *  ڼ  ؼ  ó  Ͻñ ٶϴ.
 * 
 *      hjkim@geoservice.co.kr
 *      www.gisdeveloper.co.kr
 * Ȩ  www.geoservice.co.kr 
 * 
 * մϴ.
 */

package geoservice.easyshp.shp;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.channels.FileChannel;

import com.vividsolutions.jts.geom.Coordinate;
import com.vividsolutions.jts.geom.Envelope;
import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.geom.GeometryFactory;
import com.vividsolutions.jts.geom.LineString;
import com.vividsolutions.jts.geom.LinearRing;
import com.vividsolutions.jts.geom.Polygon;

/**
 * SHP  ϴ Row Ŭ
 * 
 * @author GEOSERVICE
 * @version 1.0
 */
public class RowSHP {
	private int fid = -1; // ID 
	private Envelope mbr = null; //  MBR
	private Geometry geometry = null; //  ϴ ǥ  Geometry
	private AccessSHP control = null; //  о ̰ Geometry   Ʈ 
	
	/**
	 *  Geometry 
	 * @return  Geometryν <a href="http://www.vividsolutions.com/jts/jtshome.htm">JTS ̺귯</a> ϴ Geometry Ÿ 
	 */
	public Geometry getGeometry() {
		return geometry;
	}
	
	/**
	 * Row ID 
	 */
	public int getFID() {
		return fid;
	}

	/**
	 * Row MBR(Minimum Bounding Rectangle) 
	 */
	public Envelope getMBR() {
		return mbr;
	}

	/**
	 * 
	 * @param fid Row ID(1 )
	 * @param mbr Row MBR(Minimum Bounding Rectangle)
	 * @param control Row ޸𸮿 ø Geometry ϱ  Ʈ
	 */
	public RowSHP(int fid, Envelope mbr, AccessSHP control) {
		this.fid = fid;
		this.mbr = mbr;
		this.control = control;
	}
	
	/**
	 * Point Ÿ Geometry 
	 * @param buf Ϸκ о  ̳ʸ 
	 * @return Point Ÿ JTS Geomety
	 */
	private Geometry createPointGeometry(ByteBuffer buf) {
		Geometry geom = null;
		GeometryFactory factory = control.getGeometryFactory();		
		
		buf.position(4);
		
		double X = buf.getDouble();
		double Y = buf.getDouble();
		Coordinate coord = new Coordinate(X, Y);
		
		geom = factory.createPoint(coord);
		
		return geom;
	}
	
	/**
	 * Polyline Ÿ Geometry 
	 * @param buf Ϸκ о  ̳ʸ 
	 * @return LineString Ǵ MultiLineString Ÿ JTS Geometry 
	 */
	private Geometry createPolylineGeometry(ByteBuffer buf) {
		Geometry geom = null;
		GeometryFactory factory = control.getGeometryFactory();		
		
		buf.position(36);
		
		int numParts = buf.getInt();
		int numPoints = buf.getInt();
		int parts[] = new int[numParts+1];
		
		for(int iPart=0; iPart<numParts; ++iPart) {
			parts[iPart] = buf.getInt();
		}
		parts[numParts] = numPoints;
		
		if(numParts == 1) {
			Coordinate coords[] = new Coordinate[numPoints];
			for(int iPoint=0; iPoint<numPoints; ++iPoint) {
				double X = buf.getDouble();
				double Y = buf.getDouble();
				coords[iPoint] = new Coordinate(X, Y);
			}
			
			geom = factory.createLineString(coords);
		} else {
			LineString lineStrings[] = new LineString[numParts];
			for(int iPart=0; iPart<numParts; ++iPart) {
				int numPointsOfPart = parts[iPart+1]-parts[iPart];
				Coordinate coords[] = new Coordinate[numPointsOfPart];
				
				for(int iPoint=0; iPoint<numPointsOfPart; ++iPoint) {
					double X = buf.getDouble();
					double Y = buf.getDouble();
					coords[iPoint] = new Coordinate(X, Y);
				}
				
				lineStrings[iPart] = factory.createLineString(coords);
			}
			geom = factory.createMultiLineString(lineStrings);
		}
		
		return geom;
	}
	
	/**
	 * Polygon Ÿ Geometry 
	 * @param buf Ϸκ о  ̳ʸ 
	 * @return Polygon Ǵ MultiPolygon Ÿ JTS Geometry
	 */
	private Geometry createPolygonGeometry(ByteBuffer buf) {
		Geometry geom = null;
		GeometryFactory factory = control.getGeometryFactory();		
		
		buf.position(36);
		
		int numParts = buf.getInt();
		int numPoints = buf.getInt();
		int parts[] = new int[numParts+1];
		
		for(int iPart=0; iPart<numParts; ++iPart) {
			parts[iPart] = buf.getInt();
		}
		parts[numParts] = numPoints;
		
		if(numParts == 1) {
			Coordinate coords[] = new Coordinate[numPoints];
			for(int iPoint=0; iPoint<numPoints; ++iPoint) {
				double X = buf.getDouble();
				double Y = buf.getDouble();
				coords[iPoint] = new Coordinate(X, Y);
			}
			
			LinearRing ring = factory.createLinearRing(coords);
			geom = factory.createPolygon(ring, null);
		} else {
			Polygon polygons[] = new Polygon[numParts];
			for(int iPart=0; iPart<numParts; ++iPart) {
				int numPointsOfPart = parts[iPart+1]-parts[iPart];
				Coordinate coords[] = new Coordinate[numPointsOfPart];
				
				for(int iPoint=0; iPoint<numPointsOfPart; ++iPoint) {
					double X = buf.getDouble();
					double Y = buf.getDouble();
					coords[iPoint] = new Coordinate(X, Y);
				}
				
				LinearRing ring = factory.createLinearRing(coords);
				polygons[iPart] = factory.createPolygon(ring, null);
			}
			geom = factory.createMultiPolygon(polygons);
		}
		
		return geom;
	}
	
	/**
	 * Ϸκ о  ͷκ Geometry 
	 * @param buf Ϸκ о  
	 * @return JTS Geometry
	 */
	private Geometry createGeometry(ByteBuffer buf) {
		int shapeType = buf.getInt();
		
		if(shapeType == ShapeType.Polygon) {
			return createPolygonGeometry(buf);
		} else if(shapeType == ShapeType.Point) {
			return createPointGeometry(buf);
		} else if(shapeType == ShapeType.PolyLine) {
			return createPolylineGeometry(buf);
		}
		
		return null;
	}
	
	/**
	 * Row ϴ ǥ ޸𸮷 о 
	 * <b> ż带 ȣ   ⺻ Row fid  MBR   </b>
	 * о  ǥ  Geometry <a href="http://www.vividsolutions.com/jts/jtshome.htm">JTS ̺귯</a> ϴ Geometry
	 * @return   <code>true</code> ȯ
	 * @throws IOException  б⿡   ߻ϴ 
	 */
	public boolean load() throws IOException {
		FileChannel shpChannel = control.getStreamSHP().getChannel();
		FileChannel shxChannel = control.getStreamSHX().getChannel();
		
		ByteBuffer indexBuf = ByteBuffer.allocate(8);
		shxChannel.position(100 + (fid-1)*8);
		shxChannel.read(indexBuf);
		indexBuf.flip();
		
		int offset = indexBuf.getInt() * 2;
		int length = indexBuf.getInt() * 2;
		
		ByteBuffer chunkBuf = ByteBuffer.allocate(length);
		shpChannel.position(offset + 8);
		shpChannel.read(chunkBuf);
		chunkBuf.flip();
		chunkBuf.order(ByteOrder.LITTLE_ENDIAN);
		
		geometry = createGeometry(chunkBuf); 
		return (geometry != null);
	}
	
	/**
	 * ޸𸮿 о  Row ǥ unload Ŵ
	 * <b>unload ż带 ȣϿ Row id MBR   
	 */
	public void unload() {
		geometry = null;
	}
}